<template>
  <div id="app">
    <header class="coscine-header">
      <Navbar />
      <LoadingIndicator />
    </header>

    <div>
      <div v-if="!navigationError">
        <SidebarMenu v-if="isLoggedIn && areTosAccepted" />
        <main :class="mainContainerSizing">
          <b-container fluid>
            <Noc />
            <Internal />
            <BreadCrumbs v-if="isLoggedIn && areTosAccepted" />
            <RouterView />
          </b-container>
        </main>
        <SessionToast v-if="routeRequiresAuth" />
        <NotificationToast />
      </div>

      <main v-else>
        <!-- Router View for Error Pages -->
        <RouterView />
      </main>
    </div>

    <!-- Footer -->
    <Footer v-if="!isLoggedIn" />
  </div>
</template>

<script lang="ts">
// import the main store
import useMainStore from "@/store/index";
import useLoginStore from "@/modules/login/store";
import useUserStore from "@/modules/user/store";

export default defineComponent({
  setup() {
    const mainStore = useMainStore();
    const loginStore = useLoginStore();
    const userStore = useUserStore();

    return { mainStore, loginStore, userStore };
  },

  computed: {
    isLoggedIn(): boolean {
      return this.loginStore.isLoggedIn;
    },

    isLoading(): boolean {
      return this.mainStore.coscine.loading.counter > 0;
    },

    routeRequiresAuth(): boolean {
      return this.$route.meta?.requiresAuth ?? false;
    },

    areTosAccepted(): boolean | null | undefined {
      return this.userStore.user?.areToSAccepted;
    },

    localeChange(): string {
      return this.mainStore.coscine.locale;
    },

    sidebarMenuToggled(): boolean {
      return this.mainStore.sidebarActive;
    },

    navigationError(): boolean {
      if (this.$route.name == "not-found") {
        return true;
      } else return false;
    },

    mainContainerSizing(): string {
      if (this.isLoggedIn && this.areTosAccepted) {
        // User is logged in, sidebar is present.
        return this.sidebarMenuToggled ? "sidebar-active" : "sidebar-inactive";
      } else {
        // User is not logged in, no sidebar. Center overlay.
        return "px-4";
      }
    },
  },

  watch: {
    // Listen for token changes and reload the page to fetch data again
    "loginStore.authorization.bearer"() {
      window.location.reload();
    },

    isLoggedIn() {
      this.initialize();
    },

    isLoading(newVal: boolean, oldVal: boolean) {
      // Watcher used to set the expiration times after API calls.
      // Refer to the SessionToast.md documentation for more information.
      if (!newVal && newVal !== oldVal) {
        this.loginStore.setBearerTokenExpiration();
        this.loginStore.setCookieExpiration();
      }
    },

    localeChange() {
      this.$i18n.locale = this.localeChange;
    },
  },

  async mounted() {
    this.$i18n.locale = this.localeChange; // Set the locale on mount
    await this.initialize();
  },

  methods: {
    async initialize() {
      if (this.isLoggedIn) {
        const promises: Promise<void>[] = [];
        // Fetch Current TOS Version
        if (!this.loginStore.currentTosVersion) {
          promises.push(this.loginStore.retrieveCurrentTosVersion());
        }
        promises.push(this.initializeUser());
        await Promise.all(promises);
      }
    },

    async initializeUser() {
      if (!this.userStore.user) {
        await this.userStore.retrieveUser();
        this.userStore.setUserLanguagePreference();

        // Forward to ToS page. Don't change the logic bellow. Variable may be null or undefined.
        if (this.areTosAccepted === false) {
          this.$router.push({ name: "tos" });
        }
      }
    },
  },
});
</script>

<style>
.coscine-header {
  position: fixed;
  top: 0;
  width: 100%;
  z-index: 999;
}

main {
  margin-top: var(--sidebar-offset-top);
  padding-right: 1.5rem;
  padding-left: 0;
}

.h-divider {
  margin-top: 5px;
  margin-bottom: 10px;
  height: 1px;
  width: 100%;
  border-top: 1px solid var(--bs-primary-bg-subtle);
}

a[target="_blank"]:after {
  /* URL icon styling for a new tab. 
  CSS Code Point from icon page (https://icons.getbootstrap.com/) */
  content: " \F1C0";
  font-size: 0.8em;
  font-weight: normal;
  color: unset;
  font-family: "bootstrap-icons";
  src:
    url("bootstrap-icons.woff2?856008caa5eb66df68595e734e59580d")
      format("woff2"),
    url("bootstrap-icons.woff?856008caa5eb66df68595e734e59580d") format("woff");
}

.hasInfoPopover:after {
  /* Info icon styling. 
  CSS Code Point from icon page (https://icons.getbootstrap.com/) */
  content: " \F431";
  font-size: 0.8em;
  font-weight: normal;
  color: unset;
  font-family: "bootstrap-icons";
  src:
    url("bootstrap-icons.woff2?856008caa5eb66df68595e734e59580d")
      format("woff2"),
    url("bootstrap-icons.woff?856008caa5eb66df68595e734e59580d") format("woff");
}

#card-deck {
  /* Used to align the cards' and container's left edges */
  margin: 0em -0.5em;
}

.card-deck {
  gap: unset;
}

.sidebar-active {
  padding-left: calc(var(--sidebar-width-active) + var(--sidebar-left-margin));
  transition: all 0.3s;
}

.sidebar-inactive {
  padding-left: calc(
    var(--sidebar-width-collapsed) + var(--sidebar-left-margin)
  );
  transition: all 0.3s;
}

.v_gapped_container {
  display: flex;
  flex-direction: column;
  gap: var(--default-gap);
}

mark {
  background-color: #fff5cc;
  padding: 0;
}

img,
svg {
  vertical-align: text-bottom;
}
.toast-body {
  background-color: var(--bs-body-bg);
  color: var(--bs-body-color);
}

.multiselect--disabled .multiselect__input,
.multiselect--disabled .multiselect__single,
.multiselect--disabled .multiselect__option,
.multiselect--disabled .multiselect__select,
.multiselect--disabled .multiselect__tags,
.multiselect--disabled .multiselect__placeholder {
  background-color: var(--bs-secondary-bg);
}
.form-control:disabled,
.form-select:disabled {
  color: var(--bs-secondary-color);
}

[data-bs-theme="dark"] .b-form-tags.focus {
  color: var(--bs-primary-text-emphasis);
  background-color: var(--bs-primary-bg-subtle);
}
[data-bs-theme="dark"] .v-select ul,
[data-bs-theme="dark"] .v-select .vs__selected-options,
[data-bs-theme="dark"] .v-select .vs__dropdown-toggle,
[data-bs-theme="dark"] .v-select .vs__search,
[data-bs-theme="dark"] .v-select .vs__actions,
[data-bs-theme="dark"] .v-select .vs__actions svg {
  background-color: var(--bs-body-bg);
}
[data-bs-theme="dark"] .v-select .vs__selected div {
  color: var(--bs-white);
}
[data-bs-theme="dark"] .multiselect {
  border-radius: 20px;
}
[data-bs-theme="dark"] .multiselect__tags {
  background-color: var(--bs-body-bg);
  border: var(--bs-border-width) solid var(--bs-border-color);
  color: var(--bs-body-color);
  border-radius: var(--bs-border-radius);
}
[data-bs-theme="dark"] .multiselect__content-wrapper {
  border: 1px solid var(--bs-border-color);
}
[data-bs-theme="dark"] .multiselect--disabled,
[data-bs-theme="dark"] .multiselect__input,
[data-bs-theme="dark"] .multiselect__single,
[data-bs-theme="dark"] .multiselect__option,
[data-bs-theme="dark"] .multiselect__select {
  background-color: var(--bs-body-bg);
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] .multiselect__option--group {
  background-color: var(--bs-secondary-bg) !important;
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] .multiselect__placeholder {
  background-color: var(--bs-body-bg);
  color: var(--bs-secondary-color) !important;
}
[data-bs-theme="dark"] .multiselect--disabled .multiselect__input,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__single,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__option,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__select,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__tags,
[data-bs-theme="dark"] .multiselect--disabled .multiselect__placeholder {
  background-color: var(--bs-secondary-bg);
  color: var(--bs-body-color);
}
[data-bs-theme="dark"] a.text-primary,
[data-bs-theme="dark"] .h6.text-primary,
[data-bs-theme="dark"] .text-primary a {
  color: var(--bs-primary-text-emphasis) !important;
}
[data-bs-theme="dark"] .btn-outline-primary {
  --bs-btn-color: var(--bs-primary-text-emphasis) !important;
}
[data-bs-theme="dark"] mark {
  background-color: var(--bs-highlight-bg);
}
</style>
